// /////////////////////////////////////////////////////////////////////////
// C++ code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#include "../inc/multiplier_apb_wrapper.hpp"



multiplier_apb_wrapper::multiplier_apb_wrapper() :
    pwdata_old(0UL),
    pwrite_old(false),
    penable_old(false),
    psel_old(false),
    paddr_old(0UL),
    presetn_old(false),
    pclk_old(false),
    hif_a2t_data(
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr),
    clk(false),
    din_rdy(false),
    op1(uint16_t(0U)),
    op2(uint16_t(0U)),
    result(0UL),
    dout_rdy(false),
    multiplier_0(),
    clk_new(false),
    din_rdy_new(false),
    op1_new(uint16_t(0U)),
    op2_new(uint16_t(0U)),
    result_new(0UL),
    dout_rdy_new(false),
    process_in_queue(false),
    flag_globact_process_5_executed(false),
    flag_pclk(false),
    flag_globact_process_8_executed(false),
    flag_penable(false),
    flag_dout_rdy(false),
    flag_result(false),
    flag_globact_process_6_globact_process_7_executed(false),
    flag_pwdata(false)
{
}


multiplier_apb_wrapper::~multiplier_apb_wrapper()
{}


void multiplier_apb_wrapper::perform_bindings()
{
    multiplier_0.hif_a2t_data.clk = &clk;
    multiplier_0.hif_a2t_data.din_rdy = &din_rdy;
    multiplier_0.hif_a2t_data.op1 = &op1;
    multiplier_0.hif_a2t_data.op2 = &op2;
    multiplier_0.hif_a2t_data.result = &result_new;
    multiplier_0.hif_a2t_data.dout_rdy = &dout_rdy_new;
}


void multiplier_apb_wrapper::globact_process_5()
{
    clk_new = *hif_a2t_data.pclk;
}


void multiplier_apb_wrapper::globact_process_8()
{
    din_rdy_new = *hif_a2t_data.penable;
}


void multiplier_apb_wrapper::globact_process_9()
{
    *hif_a2t_data.pready = dout_rdy;
}


void multiplier_apb_wrapper::globact_process_10()
{
    *hif_a2t_data.prdata = result;
}


void multiplier_apb_wrapper::globact_process_6_globact_process_7()
{
    op1_new = *hif_a2t_data.pwdata;
    op2_new = *hif_a2t_data.pwdata >> 16L & 65535UL;
}


void multiplier_apb_wrapper::update_input_queue( bool synch_phase )
{
    process_in_queue = false;
    if (*hif_a2t_data.pclk != pclk_old)
    {
        pclk_old = *hif_a2t_data.pclk;
        flag_pclk = true;
        process_in_queue = true;
    }
    else
    {
        flag_pclk = false;
    }
    presetn_old = *hif_a2t_data.presetn;
    paddr_old = *hif_a2t_data.paddr;
    psel_old = *hif_a2t_data.psel;
    if (*hif_a2t_data.penable != penable_old)
    {
        penable_old = *hif_a2t_data.penable;
        flag_penable = true;
        process_in_queue = true;
    }
    else
    {
        flag_penable = false;
    }
    pwrite_old = *hif_a2t_data.pwrite;
    if (*hif_a2t_data.pwdata != pwdata_old)
    {
        pwdata_old = *hif_a2t_data.pwdata;
        flag_pwdata = true;
        process_in_queue = true;
    }
    else
    {
        flag_pwdata = false;
    }
    if (synch_phase)
    {
        multiplier_0.update_input_queue( true );
        process_in_queue = process_in_queue || multiplier_0.process_in_queue;
    }
}


void multiplier_apb_wrapper::update_event_queue()
{
    process_in_queue = false;
    update_input_queue( false );
    clk = clk_new;
    din_rdy = din_rdy_new;
    if (dout_rdy != dout_rdy_new)
    {
        dout_rdy = dout_rdy_new;
        flag_dout_rdy = true;
        process_in_queue = true;
    }
    else
    {
        flag_dout_rdy = false;
    }
    op1 = op1_new;
    op2 = op2_new;
    if (result != result_new)
    {
        result = result_new;
        flag_result = true;
        process_in_queue = true;
    }
    else
    {
        flag_result = false;
    }
    multiplier_0.update_event_queue();
    process_in_queue = process_in_queue || multiplier_0.process_in_queue;
}


void multiplier_apb_wrapper::flag_elaboration()
{
    flag_globact_process_5_executed = false;
    if (flag_pclk)
    {
        globact_process_5();
        flag_globact_process_5_executed = true;
    }
    flag_globact_process_8_executed = false;
    if (flag_penable)
    {
        globact_process_8();
        flag_globact_process_8_executed = true;
    }
    if (flag_dout_rdy)
    {
        globact_process_9();
    }
    if (flag_result)
    {
        globact_process_10();
    }
    flag_globact_process_6_globact_process_7_executed = false;
    if (flag_pwdata)
    {
        globact_process_6_globact_process_7();
        flag_globact_process_6_globact_process_7_executed = true;
    }
    if (multiplier_0.process_in_queue)
    {
        multiplier_0.flag_elaboration();
    }
}


void multiplier_apb_wrapper::start_of_simulation()
{
    globact_process_5();
    flag_globact_process_5_executed = true;
    globact_process_8();
    flag_globact_process_8_executed = true;
    globact_process_9();
    globact_process_10();
    globact_process_6_globact_process_7();
    flag_globact_process_6_globact_process_7_executed = true;
}


void multiplier_apb_wrapper::initialize()
{
    start_of_simulation();
    multiplier_0.initialize();
}




